
%{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "labgen.h"
int yylex(void);
FILE * yyin;
FILE * yyout;
char * yytext;
//extern char *** matrice;
char *** matrice=NULL;
extern variables listevars;
void yyerror(const char *);

extern int yylineno;
char file[255];

%}
%union yylval
{
int cnum ;
char* ident;
char* op;
char* dir;
}



%token<ident> IDENT
%token<cnum> CNUM
%token  SIZE
%token<cnum> IN
%token<cnum> OUT WALL PTD SHOW UNWALL END R F PTA FOR TOGGLE WH MD
%token<op> OP
%token<dir> DIR


%left  MULT DIV MOD
%left PLUS MOINS
%nonassoc NEG
%%

file:
listinstr

;
listinstr:
instruction
|listinstr instruction
;
instruction:
IDENT '=' xcst END {  }
|SIZE xcst END
|SIZE xcst ',' xcst END
|IN pt END
|WALL END
|TOGGLE END
|UNWALL END
|WALL R pt pt END
|TOGGLE R pt pt END
|UNWALL R pt pt END
|SHOW {
printf("test\n");
matrice = create_matrice(5,4);
affichmat(matrice);

point p1 = new_point(1,2);
change_val_matrice(p1, "ABC", matrice);
printf("%s\n", lecture(p1,matrice));

change_val_matrice(p1, "DEF", matrice);
printf("%s\n", lecture(p1,matrice));
affichmat(matrice);

}


|OUT list END
|WALL PTA list END
|WALL R F pt pt END
|WALL PTD pt wallptd  END
|WALL FOR wallfor END
|UNWALL PTA list END
|UNWALL R F pt pt END
|UNWALL PTD unwallptd END
|UNWALL FOR unwallfor END
|TOGGLE PTA list END
|TOGGLE R F pt pt END
|TOGGLE PTD toggleptd END
|TOGGLE FOR togglefor END
|WH pt MOINS MOINS '>'pt list1 END
|WH pt MOINS '>'pt list1 END
|MD pt destlist END;

/*
expr:
xcst
|IDENT
|expr PLUS expr
|expr MOINS expr
|expr MULT expr
|expr DIV expr;
*/

xcst:
IDENT
|CNUM
|PLUS CNUM
|MOINS CNUM
| xcst PLUS xcst
|xcst MOINS xcst
|xcst MULT xcst
| xcst DIV xcst
| xcst MOD xcst
| '(' xcst ')'  ;





wallfor:
IDENT wallfor
|IN listRange pt;

unwallfor:
IDENT unwallfor
|IN listRange  pt;


togglefor:
IDENT togglefor
|IN listRange  pt;

toggleptd:
pt
|pt ':' r |
pt toggleptd
|pt ':' r toggleptd  ;





wallptd:
pt
|pt ':' r |
pt wallptd
|pt ':' r wallptd  ;

unwallptd:
pt
|pt ':' r |
pt unwallptd
|pt ':' r unwallptd;


r:
"*"
| xcst;

pt:  '('xcst  ',' xcst')' ;


range:
'[' xcst  ':'  xcst ':'   xcst ']'
|'[' xcst  ':'  xcst ':'   xcst '['
| '['xcst  ':'  xcst '['
| '['xcst  ':'  xcst ']'
;

list:
|pt list
;


list1:
| MOINS MOINS '>' pt list1
;


destlist:
|DIR pt destlist;

listRange:
range
|range listRange;





%%
void yyerror(const char* mess){
    fprintf(stderr," %s:%i:syntaxe error (near %s) \n", file,yylineno,yytext);
    exit(1);
}

int main(int argc, char *argv[]){
    if (argc == 1){
      printf("A faire : lecture sur le flux standard d'entrée + exécutable labres\n");
    }

    else if (argc==2) {
        FILE *fp = fopen(argv[1],"r");
        if (fp!=NULL) {
	          strcpy(file,argv[1]);
            printf("Reading input from file succeded: %s\n",argv[1]);

            yyin = fp;
            listevars.last = 0;
            yyparse();
        }
        else {
            fprintf(stderr,"File doesn't exist.\n");
            exit(1);
        }
    }


   else if (argc == 3){
      printf("A faire : lecture dans le fichier argc[1] + exécutable argc[2]\n");
    }

   else{
    	fprintf(stderr,"usage: %s OR %s if OR %s if exe\n",
          argv[0],argv[0],argv[0]);
    	exit(1);
   }

    return 0;
}
